﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
[RequireComponent(typeof(Rigidbody))]

public class BoatControll : MonoBehaviour {

	public Rigidbody _rigidbody;
	public GameObject _boat;
	public GameObject _water;
	public GameObject _spawner;
	public GameObject _menu;
	public Vector3 _speed;
	public float _buoyancy = 20f;
	private float _velocity = 5f;
	public bool _right;
	public int _time;
	public int _subTime;

	void Start ()
	{
		_boat = GameObject.FindGameObjectWithTag ("Boat");
		_water = GameObject.FindGameObjectWithTag ("Water");
		_rigidbody = _boat.GetComponent<Rigidbody> ();
	}

	void Update ()
	{
		_speed = _rigidbody.velocity;
		if (10 / ((_boat.transform.position.y - _water.transform.position.y)+ 0.1f) >= 12)
		{
			_buoyancy = 10 / ((_boat.transform.position.y - _water.transform.position.y)+ 0.1f);
		}


		if (_boat.transform.position.y < _water.transform.position.y)
		{
			if (-(_boat.transform.position.y - _water.transform.position.y) * 2 > 7) {
				_velocity = -(_boat.transform.position.y - _water.transform.position.y) * 2;
			} else
			{
				_velocity = 7;
			}
			_rigidbody.velocity = (transform.up * _velocity);
		}

		//vugging
		if (_boat.transform.rotation.z <= -0.1f)
		{
			_right = true;
		}
		if (_boat.transform.rotation.z > 0.1f)
		{
			_right = false;
		}

		if (_right == true)
		{
			_boat.transform.Rotate (Vector3.forward / 4);
		} else
		{
			_boat.transform.Rotate (Vector3.forward / -4);
		}
	}

	void OnTriggerEnter (Collider other)
	{
		_rigidbody.AddForce (-_speed * 40);
	}

	void OnTriggerStay (Collider other)
	{
		if (_boat.transform.position.y > _water.transform.position.y)
		{
			_rigidbody.AddForce (transform.up * _buoyancy);
		}
	}

	void OnCollisionEnter()
	{
		Application.LoadLevel(Application.loadedLevel);
		GameObject.Destroy (gameObject);
	}
	void FixedUpdate ()
	{
		if (_subTime > 0)
		{
			_subTime -= 1;
		} else if (_subTime <= 0){_time ++; _subTime = 50;}
	}
}
